/* $Cambridge: hermes/src/prayer/prayer/banner.h,v 1.1.1.1 2003/04/15 13:00:03 dpc22 Exp $ */
/************************************************
 *    Prayer - a Webmail Interface              *
 ************************************************/

/* Copyright (c) University of Cambridge 2000 - 2002 */
/* See the file NOTICE for conditions of use and distribution. */

/* Icon banner */

struct banner_item {
    struct banner_item *next;   /* Linked list */
    char *text;                 /* Text for link */
    char *icon;                 /* Icon for link */
    char *link;                 /* Target URL for link */
    unsigned long msgno;        /* Msgno for link (0 => none) */
    BOOL padding;               /* This entry just padding */
};

struct banner {
    struct banner_item *first;  /* Start of list */
    struct banner_item *last;   /* End of list */
    struct pool *pool;          /* Allocation Pool */
    BOOL full_width;            /* T => Use full width of display */
    BOOL use_submit;            /* Use submit rather than links */
};

struct banner *banner_create(struct pool *pool);

void banner_reset(struct banner *bl, struct pool *pool, BOOL full);

void banner_use_submit(struct banner *bl, BOOL use_submit);

void banner_add(struct banner *bl, char *text, char *icon, char *link);

void
banner_msg_add(struct banner *bl,
               char *text, char *icon, char *link, unsigned long msgno);

void
banner_print(struct banner *bl, struct buffer *b, struct session *session);
