/* $Cambridge: hermes/src/prayer/prayer/cmd_abook_compose.c,v 1.1.1.1 2003/04/15 13:00:03 dpc22 Exp $ */
/************************************************
 *    Prayer - a Webmail Interface              *
 ************************************************/

/* Copyright (c) University of Cambridge 2000 - 2002 */
/* See the file NOTICE for conditions of use and distribution. */

#include "prayer_session.h"

void cmd_abook_compose(struct session *session)
{
    struct request *request = session->request;
    struct options *options = session->options;
    struct buffer *b = request->write_buffer;
    struct list_item *li;

    if (request->argc == 3) {
        string_strdup(&session->abook_compose_name, request->argv[1]);
        string_strdup(&session->abook_compose_email, request->argv[2]);

        string_canon_decode(session->abook_compose_name);
        string_canon_decode(session->abook_compose_email);
    }

    if (list_length(options->role_list) == 0L) {
        session_redirect(session, request, "abook_compose2");
        return;
    }

    /* Title bar */
    html_start(session, b, "Select Role");
    html_banner_toolbar(session, b, "abook_compose", 0);

    bputs(b, "<h1 align=\"center\">Roles</h1>");
    bputs(b, "Options:" CRLF "<ol>" CRLF);

    html_session_bprintf(session, b, "<li><a href=\"",
                         "\">Default</a>" CRLF,
                         "abook_compose2?role=default");

    for (li = options->role_list->head; li; li = li->next) {
        struct role *role = (struct role *) li;

        html_session_bprintf(session, b, "<li><a href=\"", "\">",
                             "abook_compose2?role=%s",
                             string_url_encode(request->pool, role->name));
        html_quote_string(b, role->name);
        bputs(b, "</a>" CRLF);
    }
    bputs(b, "</ol>" CRLF);

    html_form_start(session, b, "POST", "compose/cancel");
    html_form_submit(b, "sub_cancel", "Cancel");
    html_form_end(b);

    html_end(b);
    /* Send out the response */
    response_html(request, 200);
}
