/* $Cambridge: hermes/src/prayer/prayer/cmd_create.c,v 1.1.1.1 2003/04/15 13:00:03 dpc22 Exp $ */
/************************************************
 *    Prayer - a Webmail Interface              *
 ************************************************/

/* Copyright (c) University of Cambridge 2000 - 2002 */
/* See the file NOTICE for conditions of use and distribution. */

#include "prayer_session.h"

void cmd_create(struct session *session)
{
    struct request *request = session->request;
    char *mailbox, *type;
    char *path, *ml_path;

    if (request->argc < 2) {
        session_redirect(session, request, "error");
        return;
    }

    request_decode_get(request);

    if ((mailbox = assoc_lookup(request->form, "name")) == NIL) {
        session_redirect(session, request, "error");
        return;
    }

    if ((type = assoc_lookup(request->form, "type")) == NIL) {
        session_redirect(session, request, "error");
        return;
    }

    if (!string_filename_valid(mailbox)) {
        session_message(session, "Name contained illegal characters");
    } else {
        if (session->cwd && session->cwd[0])
            path = pool_strcat3(request->pool, session->cwd, "/", mailbox);
        else
            path = mailbox;

        if (!strcmp(type, "directory"))
            ml_path = pool_strcat(request->pool, path, "/");
        else
            ml_path = path;

        ml_clear_error();
        ml_have_close();
        if (!ml_create(session, session->stream,
                       session_mailbox(session, request->pool, ml_path))) {
            if (ml_have_close()) {
                session_redirect(session, request, "restart");
                return;
            }
        }

        if (!strcmp(type, "directory")) {
            if (ml_have_error()) {
                session_message(session,
                                "Failed to create directory: %s - %s",
                                path, ml_errmsg());
                session_log(session,
                            "[cmd_create]Failed to create directory: %s",
                            path);
            } else {
                session_message(session, "Created directory: %s", path);
                session_log(session,
                            "[cmd_create] Created directory: %s", path);
                dircache_add(session->dircache, path, T);
            }
        } else {
            if (ml_have_error()) {
                session_message(session,
                                "Failed to create mailbox: %s - %s",
                                path, ml_errmsg());
                session_log(session,
                            "[cmd_create] Failed to create mailbox: %s",
                            path);
            } else {
                session_message(session, "Created mailbox: %s", path);
                session_log(session, "[cmd_create] Created mailbox: %s",
                            path);
                dircache_add(session->dircache, path, NIL);
            }
        }
    }

    /* Redirect back to previous command */
    session_redirect(session, request, request->argv[1]);
}
