/* $Cambridge: hermes/src/prayer/prayer/cmd_forward.c,v 1.1.1.1 2003/04/15 13:00:03 dpc22 Exp $ */
/************************************************
 *    Prayer - a Webmail Interface              *
 ************************************************/

/* Copyright (c) University of Cambridge 2000 - 2002 */
/* See the file NOTICE for conditions of use and distribution. */

#include "prayer_session.h"

void cmd_forward(struct session *session)
{
    struct request *request = session->request;
    struct options *options = session->options;
    struct prefs *prefs = options->prefs;
    struct buffer *b = request->write_buffer;
    MAILSTREAM *stream = session->stream;
    struct list_item *li;
    unsigned long count, msgno, msguid;

    if ((request->argc > 1) && !strcmp(request->argv[1], "aggregate")) {
        if (prefs->use_mark_persist)
            count = msgmap_marked_count(session->zm);
        else
            count = msgmap_tmp_marked_count(session->zm);

        if (count > 1)
            session_message(session, "Forwarding %lu marked messages",
                            count);
        else if (count == 1)
            session_message(session, "Forwarding single marked message");
        else {
            session_message(session, "No marked messages to forward");
            session_redirect(session, request, "list");
            return;
        }
        session->aggregate = T;
    } else if (request->argc > 1) {
        if (request->argc < 3) {
            session_redirect(session, request, "error");
            return;
        }
        msgno = atoi(request->argv[1]);
        msguid = atoi(request->argv[2]);

        if (!(msgno = stream_check_uid(session, stream, msgno, msguid))) {
            session_redirect(session, request, "list");
            return;
        }

        session->aggregate = NIL;
        session->current = atoi(request->argv[1]);
        session_message(session, "Forwarding message %lu",
                        session->current);
    }

    if (list_length(options->role_list) == 0L) {
        cmd_forward1(session);
        return;
    }

    /* Title bar */
    html_start(session, b, "Select Role");
    html_banner_toolbar(session, b, "forward", 0);

    /* Title Line */
    bputs(b, "<h1 align=\"center\">Roles</h1>");

    bputs(b, "Options:" CRLF "<ol>" CRLF);

    html_session_bputs(session, b, "  <li><a href=\"",
                       "\">Default</a>" CRLF, "forward1?role=default");

    for (li = options->role_list->head; li; li = li->next) {
        struct role *role = (struct role *) li;

        html_session_bprintf(session, b, "  <li><a href=\"", "\">",
                             "forward1?role=%s",
                             string_url_encode(request->pool, role->name));
        html_quote_string(b, role->name);
        bputs(b, "</a>" CRLF);
    }

    bputs(b, "</ol>" CRLF);

    html_form_start(session, b, "POST", "compose/cancel");
    html_form_submit(b, "sub_cancel", "Cancel");
    html_form_end(b);

    html_end(b);
    /* Send out the response */
    response_html(request, 200);
}
