/* $Cambridge: hermes/src/prayer/prayer/cmd_include.c,v 1.1.1.1 2003/04/15 13:00:03 dpc22 Exp $ */
/************************************************
 *    Prayer - a Webmail Interface              *
 ************************************************/

/* Copyright (c) University of Cambridge 2000 - 2002 */
/* See the file NOTICE for conditions of use and distribution. */

#include "prayer_session.h"

static void generate_form(struct session *session)
{
    struct request *request = session->request;
    struct buffer *b = request->write_buffer;

    /* Title bar */
    html_start(session, b, "Include");
    html_banner_toolbar(session, b, "include", 0);

    /* Include form */
    bprintf(b,
            "<h1 align=\"center\">Include local file in message body</h1>"
            CRLF);

    html_session_bputs(session, b,
                       "<form method=\"POST\" action=\"",
                       "\" enctype=\"multipart/form-data\">" CRLF,
                       "include");

    bputs(b, "File <input align=\"middle\" type=\"file\" ");
    bputs(b, "name=\"file\" size=\"40\">" CRLF);
    bputs(b, "<input type=\"submit\" value=\"Include\">");
    bputs(b, "</form>" CRLF);

    html_form_start(session, b, "POST", "include/cancel");
    html_form_submit(b, "sub_cancel", "Back to Compose Screen");
    html_form_end(b);

    response_html(request, 200);        /* Success */
}


void cmd_include(struct session *session)
{
    struct request *request = session->request;
    struct draft *draft = session->draft;
    char *start, *end;

    if ((request->argc >= 2) && (!strcmp(request->argv[1], "cancel"))) {
        session_redirect(session, request, "compose");
        return;
    }

    if (request->method != POST) {
        generate_form(session);
        return;
    }

    request_decode_post_multipart(request, NIL, &start, &end);
    *end = '\0';

    session_log(session, "[cmd_include] Included %lu bytes", end - start);

    if (draft->body && draft->body[0])
        draft->body = pool_strcat3(draft->pool, draft->body, CRLF, start);
    else
        draft->body = pool_strdup(draft->pool, start);

    session_redirect(session, request, "compose");
}
