/* $Cambridge: hermes/src/prayer/prayer/cmd_logout.c,v 1.1.1.1 2003/04/15 13:00:03 dpc22 Exp $ */
/************************************************
 *    Prayer - a Webmail Interface              *
 ************************************************/

/* Copyright (c) University of Cambridge 2000 - 2002 */
/* See the file NOTICE for conditions of use and distribution. */

#include "prayer_session.h"

void cmd_logout(struct session *session)
{
    struct config *config = session->config;
    struct request *request = session->request;
    struct prefs *prefs = session->options->prefs;
    struct draft *draft = session->draft;
    struct buffer *b = request->write_buffer;
    struct banner *banner = banner_create(request->pool);
    char *back = pool_join(request->pool, '/', &request->argv[1]);

    if (!prefs->confirm_logout) {
        session_redirect(session, request, "exit");
        return;
    }

    html_start(session, b, "Confirm Logout");

    bputs(b, "<h1 align=\"center\">");

    if (config->login_service_name) {
        bprintf(b,
                "Confirm logout from %s Webmail system",
                config->login_service_name);
    } else
        bputs(b, "Confirm logout from Webmail system");

    bputs(b, "</h1>" CRLF);

    banner_reset(banner, request->pool, T);
    banner_add(banner, "Cancel", "cross.gif", back);
    banner_add(banner, "Okay", "tick.gif", "exit");
    banner_print(banner, b, session);

    if (draft->have_draft && draft->body && draft->body[0]) {
        bputs(b, "<table><tr>");
        bputs(b, "<td><b>Warning:</b></td>");
        bputs(b, "<td>Draft message currently active</td>");
        bputs(b, "</tr>" CRLF);
        bputs(b, "<tr><td>&nbsp;</td>");
        bputs(b,
              "<td>This message will be discarded if you exit now</td>");
        bputs(b, "</tr></table>" CRLF);
    }

    html_end(b);

    /* Send out the response */
    response_html(request, 200);
}
