/* $Cambridge: hermes/src/prayer/prayer/cmd_manage.c,v 1.8 2003/08/07 11:39:40 dpc22 Exp $ */
/************************************************
 *    Prayer - a Webmail Interface              *
 ************************************************/

/* Copyright (c) University of Cambridge 2000 - 2002 */
/* See the file NOTICE for conditions of use and distribution. */

#include "prayer_session.h"

static void generate_form(struct session *session)
{
    struct user_agent *user_agent = session->user_agent;
    struct request *request = session->request;
    struct buffer *b = request->write_buffer;

    /* Title bar */
    html_start(session, b, "Account Management");
    html_banner_toolbar(session, b, "manage", 0);

    /* Title line */
    bprintf(b, "<h2 align=\"center\">Account Management</h2>" CRLF);

    /* Form body */
    html_form_start(session, b, "POST", "manage");

    bputs(b, "<table>" CRLF);
    bputs(b, "<tr>" CRLF);
    bputs(b, "<td>User Preferences:</td>" CRLF);
    bputs(b, "</tr>" CRLF);
    bputs(b, "</table>" CRLF);

    bputs(b, "<table>" CRLF);
    bputs(b, "<tr>" CRLF);
    html_form_table_submit(b, "sub_prefs", "Preferences");
    if (user_agent->use_debug)
        html_form_table_submit(b, "sub_user_agent",
                               "User Agent Debugging");

    bputs(b, "</tr>" CRLF);
    bputs(b, "</table>" CRLF);

    if (session->accountd_server && session->accountd_server[0]) {
        bputs(b, "<table>" CRLF);
        bputs(b, "<tr>" CRLF);
        bputs(b, "<td>Account Management:</td>" CRLF);
        bputs(b, "</tr>" CRLF);
        bputs(b, "</table>" CRLF);

        bputs(b, "<table>" CRLF);
        bputs(b, "<tr>" CRLF);
        html_form_table_submit(b, "sub_passwd", "Change Password");
        html_form_table_submit(b, "sub_fullname", "Change Fullname");
        html_form_table_submit(b, "sub_quota", "Check Quota");
        bputs(b, "</tr>" CRLF);
        bputs(b, "</table>" CRLF);

        bputs(b, "<table>" CRLF);
        bputs(b, "<tr>" CRLF);
        bputs(b, "<td>Mail Processing:</td>" CRLF);
        bputs(b, "</tr>" CRLF);
        bputs(b, "</table>" CRLF);

        bputs(b, "<table>" CRLF);
        bputs(b, "<tr>" CRLF);
        html_form_table_submit(b, "sub_redirect", "Redirect");
        html_form_table_submit(b, "sub_vacation", "Vacation");

        if (!session->sieved_server)
            html_form_table_submit(b, "sub_vaclog", "Vacation log");

        html_form_table_submit(b, "sub_filter", "Filters");
        html_form_table_submit(b, "sub_block", "Blocks");
        html_form_table_submit(b, "sub_spam", "Junk Email");
        if (session->sieved_server)
            html_form_table_submit(b, "sub_sieve", "Advanced");

        bputs(b, "</tr>" CRLF);
        bputs(b, "</table>" CRLF);

    }

    bputs(b, "<table>" CRLF);
    bputs(b, "<tr>" CRLF);
    bputs(b, "<td>Miscellaneous:</td>" CRLF);
    bputs(b, "</tr>" CRLF);
    bputs(b, "</table>" CRLF);

    bputs(b, "<table>" CRLF);
    bputs(b, "<tr>" CRLF);
    html_form_table_submit(b, "sub_dictionary", "Personal Dictionary");
    html_form_table_submit(b, "sub_roles", "Roles");
    bputs(b, "</tr>" CRLF);
    bputs(b, "</table>" CRLF);

    /* End of form */
    html_form_end(b);
    html_end(b);

    response_html(request, 200);
}

void cmd_manage(struct session *session)
{
    struct request *request = session->request;
    struct assoc *h = NIL;
    char *s;

    /* Record last command for compose/cancel and friends */
    session->compose_parent_cmd = "manage";

    if (request->method != POST) {
        /* Save options if anything changed */
        if (session->options->save)
            session_streams_save_options(session);

        generate_form(session);
        return;
    }

    request_decode_post(request);
    h = request->form;

    if ((s = assoc_lookup(h, "sub_cancel"))) {
        /* Free up working preferences and return to list screen */
        session_redirect(session, request, "list");
        return;
    }

    if (assoc_lookup(h, "sub_prefs")) {
        session_redirect(session, request, "prefs");
        return;
    }

    if (assoc_lookup(h, "sub_user_agent")) {
        session_redirect(session, request, "user_agent");
        return;
    }

    if (assoc_lookup(h, "sub_passwd")) {
        session_redirect(session, request, "passwd");
        return;
    }

    if (assoc_lookup(h, "sub_fullname")) {
        session_redirect(session, request, "fullname");
        return;
    }

    if (assoc_lookup(h, "sub_quota")) {
        session_redirect(session, request, "quota");
        return;
    }

    if (assoc_lookup(h, "sub_redirect")) {
        session_redirect(session, request, "redirect");
        return;
    }

    if (assoc_lookup(h, "sub_vacation")) {
        session_redirect(session, request, "vacation");
        return;
    }

    if (assoc_lookup(h, "sub_vaclog")) {
        session_redirect(session, request, "vaclog");
        return;
    }

    if (assoc_lookup(h, "sub_filter")) {
        session_redirect(session, request, "filter");
        return;
    }

    if (assoc_lookup(h, "sub_block")) {
        session_redirect(session, request, "block");
        return;
    }

    if (assoc_lookup(h, "sub_spam")) {
        session_redirect(session, request, "spam");
        return;
    }

    if (assoc_lookup(h, "sub_sieve")) {
        session_redirect(session, request, "sieve");
        return;
    }

    if (assoc_lookup(h, "sub_roles")) {
        session_redirect(session, request, "roles_list");
        return;
    }

    if (assoc_lookup(h, "sub_dictionary")) {
        session_redirect(session, request, "dictionary");
        return;
    }

    session_redirect(session, request, "list");
}
