/* $Cambridge: hermes/src/prayer/prayer/cmd_reply1.c,v 1.1.1.1 2003/04/15 13:00:03 dpc22 Exp $ */
/************************************************
 *    Prayer - a Webmail Interface              *
 ************************************************/

/* Copyright (c) University of Cambridge 2000 - 2002 */
/* See the file NOTICE for conditions of use and distribution. */

#include "prayer_session.h"

void cmd_reply1(struct session *session)
{
    struct request *request = session->request;
    struct options *options = session->options;
    unsigned long msgno;
    unsigned long msgno_uid;
    MAILSTREAM *stream = session->stream;
    MESSAGECACHE *elt;
    ENVELOPE *env;
    struct assoc *h;
    struct list_item *li;
    struct buffer *b = request->write_buffer;

    if (request->method == POST) {
        request_decode_post(request);
        if (assoc_lookup((h = request->form), "cancel")) {
            session_redirect(session, request,
                             session->compose_parent_cmd);
            return;
        }
        session->reply_all = (assoc_lookup(h, "all")) ? T : NIL;
    }

    if (list_length(options->role_list) == 0L) {
        cmd_reply2(session);
        return;
    }

    msgno = session->current;
    msgno_uid = ml_uid(session, stream, msgno);

    if (!((elt = ml_elt(session, stream, msgno)) &&
          (env = ml_fetch_structure(session, stream, msgno, NIL, 0)))) {
        session_redirect(session, request, "restart");
        return;
    }

    /* Title bar */
    html_start(session, b, "Select Role");
    html_banner_toolbar(session, b, "reply1", 0);

    /* Title line */
    bputs(b, "<h1 align=\"center\">Select Role</h1>");

    bputs(b, "Options:" CRLF "<ol>" CRLF);

    html_session_bputs(session, b,
                       "  <li><a href=\"", "\">Default</a>" CRLF,
                       "reply2?role=default");

    for (li = options->role_list->head; li; li = li->next) {
        struct role *role = (struct role *) li;

        html_session_bprintf(session, b, "  <li><a href=\"", "\">",
                             "reply2?role=%s",
                             string_url_encode(request->pool, role->name));
        html_quote_string(b, role->name);
        bputs(b, "</a>" CRLF);
    }

    bputs(b, "</ol>" CRLF);

    html_form_start(session, b, "POST", "compose/cancel");
    html_form_submit(b, "sub_cancel", "Cancel");
    html_form_end(b);

    html_end(b);
    /* Send out the response */
    response_html(request, 200);
}
