/* $Cambridge: hermes/src/prayer/prayer/cmd_rm.c,v 1.1.1.1 2003/04/15 13:00:03 dpc22 Exp $ */
/************************************************
 *    Prayer - a Webmail Interface              *
 ************************************************/

/* Copyright (c) University of Cambridge 2000 - 2002 */
/* See the file NOTICE for conditions of use and distribution. */

#include "prayer_session.h"

void cmd_rm(struct session *session)
{
    struct request *request = session->request;
    struct options *options = session->options;
    struct prefs *prefs = options->prefs;
    struct buffer *b = request->write_buffer;
    struct banner *banner = banner_create(request->pool);
    char *cmd;

    if (request->argc < 3) {
        session_redirect(session, request, "folders");
        return;
    }

    if (!prefs->confirm_rm) {
        cmd_rm1(session);
        return;
    }

    if (!strcmp(request->argv[1], "directory")) {
        html_start(session, b, "Confirm Directory deletion");
        bprintf(b,
                "<h2 align=\"center\">Confirm directory deletion: \"%s\"</h2>"
                CRLF,
                string_canon_decode(pool_strdup
                                    (request->pool, request->argv[2])));

    } else {
        html_start(session, b, "Confirm Mail folder deletion");
        bprintf(b,
                "<h2 align=\"center\">Confirm folder deletion: \"%s\"</h2>"
                CRLF,
                string_canon_decode(pool_strdup
                                    (request->pool, request->argv[2])));
    }

    cmd = pool_printf(request->pool, "rm1/%s/%s",
                      request->argv[1], request->argv[2]);

    banner_reset(banner, request->pool, T);
    banner_add(banner, "Cancel", "cross.gif", "folders");
    banner_add(banner, "Okay", "tick.gif", cmd);
    banner_print(banner, b, session);

    html_end(b);

    /* Send out the response */
    response_html(request, 200);
}
