/* $Cambridge: hermes/src/prayer/prayer/cmd_roles_list.c,v 1.1.1.1 2003/04/15 13:00:03 dpc22 Exp $ */
/************************************************
 *    Prayer - a Webmail Interface              *
 ************************************************/

/* Copyright (c) University of Cambridge 2000 - 2002 */
/* See the file NOTICE for conditions of use and distribution. */

#include "prayer_session.h"

void cmd_roles_list(struct session *session)
{
    struct request *request = session->request;
    struct options *options = session->options;
    struct buffer *b = request->write_buffer;
    struct list_item *li;
    struct assoc *h = NIL;

    if (request->method == POST) {
        request_decode_post(request);
        h = request->form;

        if (assoc_lookup(h, "sub_cancel")) {
            session_redirect(session, request, "manage");
            return;
        }

        if (assoc_lookup(h, "sub_new")) {
            session_redirect(session, request, "roles_entry");
            return;
        }
    }

    /* Title bar */
    html_start(session, b, "Roles");
    html_banner_toolbar(session, b, "roles_list", 0);

    bputs(b, "<h1 align=\"center\">Roles</h1>" CRLF);

    if (options->role_list->head) {
        bputs(b, "<p>Existing roles:</p>" CRLF);
        bputs(b, "<ol>" CRLF);

        for (li = options->role_list->head; li; li = li->next) {
            struct role *role = (struct role *) li;

            html_session_bprintf
                (session, b, "<li><a href=\"", "\">",
                 ("roles_entry?alias=%s&amp;personal=%s&amp;from=%s&amp;"
                  "reply_to=%s&amp;fcc=%s&amp;signature=%s"), ((role->name)
                                                               ?
                                                               string_url_encode
                                                               (request->
                                                                pool,
                                                                role->
                                                                name) :
                                                               ""),
                 ((role->personal)
                  ? string_url_encode(request->pool, role->personal) : ""),
                 ((role->from)
                  ? string_url_encode(request->pool, role->from) : ""),
                 ((role->reply_to)
                  ? string_url_encode(request->pool, role->reply_to) : ""),
                 ((role->fcc)
                  ? string_url_encode(request->pool, role->fcc) : ""),
                 ((role->signature)
                  ? string_url_encode(request->pool,
                                      role->signature) : ""));

            html_quote_string(b, role->name);
            bputs(b, "</a>" CRLF);
        }
        bputs(b, "</ol>" CRLF);
    } else
        bputs(b, "<p>No roles defined</p>" CRLF);

    html_form_start(session, b, "POST", "roles_list");
    bputs(b, "<table><tr>" CRLF);
    html_form_table_submit(b, "sub_cancel", "Back to Options Screen");
    html_form_table_submit(b, "sub_new", "Add new role");
    bprintf(b, "</tr></table>" CRLF);
    html_form_end(b);

    html_end(b);

    /* Send out the response */
    response_html(request, 200);
}
