/* $Cambridge: hermes/src/prayer/prayer/cmd_user_agent.c,v 1.1.1.1 2003/04/15 13:00:03 dpc22 Exp $ */
/************************************************
 *    Prayer - a Webmail Interface              *
 ************************************************/

/* Copyright (c) University of Cambridge 2000 - 2002 */
/* See the file NOTICE for conditions of use and distribution. */

#include "prayer_session.h"

static void
bputs_line(struct buffer *b, char *title,
           BOOL value1, BOOL value2, BOOL value3)
{
    bputs(b, "<tr>");
    bprintf(b, "<td>%s</td>", title);
    bprintf(b, "<td>%s</td>", (value1) ? "TRUE" : "FALSE");
    bprintf(b, "<td>%s</td>", (value2) ? "TRUE" : "FALSE");
    bprintf(b, "<td>%s</td>", (value3) ? "TRUE" : "FALSE");

    if ((value1 != value2) || (value1 != value3) || (value1 != value2))
        bputs(b, "<td>YES</td>");
    else
        bputs(b, "<td>NO</td>");

    bputs(b, "</tr>" CRLF);
}

void cmd_user_agent(struct session *session)
{
    struct request *request = session->request;
    struct user_agent *ua_default = user_agent_create(request->pool);
    struct user_agent *ua_initial = session->ua_initial;
    struct user_agent *ua_actual = session->user_agent;
    struct buffer *b = request->write_buffer;
    char *s;

    /* Title bar */
    html_start(session, b, "User Agent Debugging");
    html_banner_toolbar(session, b, "user_agent", 0);

    /* Title line */
    bprintf(b, "<h2 align=\"center\">User Agent Debugging</h2>" CRLF);

    bputs(b, "<table>" CRLF);
    bputs(b, "<tr>");
    bputs(b, "<td>User-Agent:</td>");

    bputs(b, "<td>");
    if ((s = assoc_lookup(request->hdrs, "user-agent")) && s[0]) {
        user_agent_setup_browser(ua_default, s);
        html_quote_string(b, s);
    } else {
        bputs(b, "Unknown");
    }
    bputs(b, "</td>");

    bputs(b, "</tr>" CRLF);
    bputs(b, "</table>" CRLF);

    bputs(b, "<table border=1>" CRLF);
    bputs(b, "<tr>");
    bputs(b, "<td>Property</td>");
    bputs(b, "<td>Default</td>");
    bputs(b, "<td>Initial</td>");
    bputs(b, "<td>Live</td>");
    bputs(b, "<td>Changed?</td>");
    bputs(b, "</tr>" CRLF);

    bputs_line(b, "Override automatic frontend configuration",
               ua_default->manual, ua_initial->manual, ua_actual->manual);

    bputs_line(b, "Override user preferences",
               ua_default->use_override,
               ua_initial->use_override, ua_actual->use_override);

    bputs_line(b, "Use Icons",
               ua_default->use_icons,
               ua_initial->use_icons, ua_actual->use_icons);

    bputs_line(b, "Use HTTP Cookie for Session",
               ua_default->use_cookie,
               ua_initial->use_cookie, ua_actual->use_cookie);

    bputs_line(b, "Use Page Substitution",
               ua_default->use_substitution,
               ua_initial->use_substitution, ua_actual->use_substitution);

    bputs_line(b, "Use Direct Connection to session server",
               ua_default->use_direct,
               ua_initial->use_direct, ua_actual->use_direct);

    bputs_line(b, "Use HTTP/1.1",
               ua_default->use_http_1_1,
               ua_initial->use_http_1_1, ua_actual->use_http_1_1);

    bputs_line(b, "Use HTTP/1.1 Pipelining",
               ua_default->use_pipelining,
               ua_initial->use_pipelining, ua_actual->use_pipelining);

    bputs_line(b, "Use HTTP links in HTTPS pages",
               ua_default->use_embed_http,
               ua_initial->use_embed_http, ua_actual->use_embed_http);

    bputs_line(b, "Use Persistent Connections",
               ua_default->use_persist,
               ua_initial->use_persist, ua_actual->use_persist);

    bputs_line(b, "Use Short URLs",
               ua_default->use_short,
               ua_initial->use_short, ua_actual->use_short);

    bputs_line(b, "Use gzip compression",
               ua_default->use_gzip,
               ua_initial->use_gzip, ua_actual->use_gzip);

    bputs_line(b, "Is Netscape 4",
               ua_default->is_netscape4,
               ua_initial->is_netscape4, ua_actual->is_netscape4);

    bputs(b, "<tr>");
    bputs(b, "</tr>" CRLF);

    bputs(b, "</table>");

    bputs(b, "<table>" CRLF);
    bputs(b, "<tr>");
    bputs(b, "<td>Default:</td>");
    bputs(b, "<td>Default behaviour for this browser</td>");
    bputs(b, "</tr>" CRLF);
    bputs(b, "<tr>");
    bputs(b, "<td>Initial:</td>");
    bputs(b, "<td>Initial behaviour defined by debug login screen</td>");
    bputs(b, "</tr>" CRLF);
    bputs(b, "<tr>");
    bputs(b, "<td>Live:</td>");
    bputs(b, "<td>Actual behaviour with user preferences applied</td>");
    bputs(b, "</tr>" CRLF);
    bputs(b, "</table>" CRLF);

    html_end(b);
    response_html(request, 200);
}
