/* $Cambridge: hermes/src/prayer/prayer/dircache.h,v 1.1.1.1 2003/04/15 13:00:03 dpc22 Exp $ */
/************************************************
 *    Prayer - a Webmail Interface              *
 ************************************************/

/* Copyright (c) University of Cambridge 2000 - 2002 */
/* See the file NOTICE for conditions of use and distribution. */

/* Directory cache is a tree structure reflecting filesystem layout */

struct dircache {
    struct pool *pool;          /* Allocation pool */
    struct dircache *next;      /* Linked list: dircaches at this level */
    struct dircache *children;  /* Child nodes */
    char *name;                 /* Name of this node */
    struct dirlist *dirlist;    /* Directory list: Page in on demand */
};

#define DIRCACHE_PREFERRED_POOL_SIZE (4096)

struct dircache *dircache_create(void);
void dircache_free(struct dircache *dc);
struct dircache *dircache_lookup(struct session *session, char *name);
struct dircache *dircache_insert(struct session *session, char *name);
struct dirlist *dircache_fetch(struct session *session, char *name);
BOOL dircache_invalidate(struct session *session, char *name);

BOOL dircache_add(struct dircache *dc, char *name, BOOL isdir);
BOOL dircache_delete(struct dircache *dc, char *name);
BOOL dircache_rename(struct dircache *dc, char *oldname, char *newname);
