/* $Cambridge: hermes/src/prayer/prayer/html.h,v 1.1.1.1 2003/04/15 13:00:03 dpc22 Exp $ */
/************************************************
 *    Prayer - a Webmail Interface              *
 ************************************************/

/* Copyright (c) University of Cambridge 2000 - 2002 */
/* See the file NOTICE for conditions of use and distribution. */

/* HTML meta information */

void html_start(struct session *session, struct buffer *b, char *title);
void html_help_start(struct session *session, struct buffer *b,
                     char *title);
void html_end(struct buffer *b);
void html_banner_start(struct buffer *b, BOOL full);
void html_banner_end(struct buffer *b);

void
html_session_bputs(struct session *session,
                   struct buffer *b, char *prefix, char *suffix, char *s);

void
html_session_bprintf(struct session *session, struct buffer *b,
                     char *prefix, char *suffix, char *fmt, ...);

void
html_icon(struct session *session, struct buffer *b, char *icon,
          char *alt);


/* Non-table elements: simple buttons and links */

void
html_textlink_session(struct session *session,
                      struct buffer *b, char *cmd, char *text);

void
html_button_msg(struct session *s,
                struct buffer *b,
                char *cmd, unsigned long msgno, char *img, char *alt);

void html_textlink_mailbox(struct session *s, struct buffer *b, char *cmd, char *mailbox,       /* Must be canonical! */
                           char *text);

void
html_textlink_msg(struct session *s,
                  struct buffer *b,
                  char *cmd, unsigned long msgno, char *text);

/* Table elements: simple buttons and links */
void
html_button_table(struct session *s, struct buffer *b,
                  char *img, char *alt, char *link);

void
html_button_inactive_table(struct session *s, struct buffer *b,
                           char *img, char *alt);

void
html_button_session_table(struct session *s, struct buffer *b,
                          char *cmd, char *img, char *alt);

void
html_button_msg_table(struct session *s, struct buffer *b, char *cmd,
                      unsigned long msgno, char *img, char *alt);

void
html_button_mailbox_table(struct session *s,
                          struct buffer *b,
                          char *cmd, char *mailbox, char *img, char *alt);

void
html_textlink_session_table(struct session *s,
                            struct buffer *b, char *cmd, char *text);

void html_textlink_mailbox_table(struct session *s, struct buffer *b, char *cmd, char *mailbox, /* Must be canonical! */
                                 char *text);

void
html_textlink_msg_table(struct session *s, struct buffer *b, char *cmd,
                        unsigned long msgno, char *text);

/* Form items */

void
html_form_start(struct session *s, struct buffer *b,
                char *method, char *cmd);

void html_form_end(struct buffer *b);

/* Form items without table */

void html_form_submit(struct buffer *b, char *name, char *value);
void html_form_hidden(struct buffer *b, char *name, char *value);
void
html_form_field(struct buffer *b,
                char *desc, char *name, char *value, unsigned long size);

void
html_form_checkbox(struct buffer *b, char *desc, char *name, BOOL enabled);
void
html_form_textarea(struct session *session,
                   struct buffer *b, char *name, char *value,
                   unsigned long width, unsigned long height);

/* Form items for table */

void html_form_table_submit(struct buffer *b, char *name, char *value);
void html_form_table_hidden(struct buffer *b, char *name, char *value);
void
html_form_table_field(struct buffer *b,
                      char *desc, char *name, char *value,
                      unsigned long size);

void
html_form_table_checkbox(struct buffer *b, char *desc,
                         char *name, BOOL enabled);

void
html_form_table_textarea(struct buffer *b, char *name, char *value,
                         unsigned long width, unsigned long height);


/* Print Session message */
void html_session_message(struct session *s, struct buffer *b);

/* Toolbar stuff */

#define HTML_BANNER_CALLBACK_SAVE   (1) /* For change/save form */
#define HTML_BANNER_CALLBACK_ALL    (2) /* For all actions      */
#define HTML_BANNER_SUPPRESS_STATUS (4) /* Supress status line  */

void
html_banner_toolbar_help(struct session *session,
                         struct buffer *b, char *node, char *back);

void
html_banner_toolbar(struct session *session,
                    struct buffer *b, char *node, int bitmask);

/* HTML quoting stuff */

void html_quote_char(struct buffer *b, unsigned char c);

void html_quote_string(struct buffer *b, char *t);

void
html_quote_linewrap(struct buffer *b, char *t,
                    unsigned long line_length, BOOL indent);
