/* $Cambridge: hermes/src/prayer/prayer/idled_main.c,v 1.1.1.1 2003/04/15 13:00:03 dpc22 Exp $ */
/************************************************
 *    Prayer - a Webmail Interface              *
 ************************************************/

/* Copyright (c) University of Cambridge 2000 - 2002 */
/* See the file NOTICE for conditions of use and distribution. */

#include "prayer_shared.h"
#include "idled_server.h"

int main(int argc, char *argv[], char *envp[])
{
    char *config_filename = CONFIG_FILE;
    struct config *config = config_create();
    int i;

    /* Disable supplementary groups, look for (temporary) unprivileged group */
    if (getuid() == 0) {
        struct group *group;

        setgroups(0, NIL);

        if ((group = getgrnam("other")) != NIL)
            setgid(group->gr_gid);
        else if ((group = getgrnam("nobody")) != NIL)
            setgid(group->gr_gid);
    }

    initsetproctitle("prayer-frontend", argc, argv, envp);

    if (getenv("PRAYER_CONFIG_FILE"))
        config_filename = getenv("PRAYER_CONFIG_FILE");

    for (i = 1; i < argc; i++) {
        if (!strncmp(argv[i], "--config-file=", strlen("--config-file="))) {

            config_filename = strdup(argv[i] + strlen("--config-file="));
        } else if (!strcmp(argv[i], "--config-option")) {
            i++;                /* Processes next argv */
        } else {
            fprintf(stderr, "Unknown option: %s\n", argv[i]);
            exit(1);
        }
    }

    config = config_create();
    if (!config_parse_file(config, config_filename))
        exit(1);

    for (i = 1; i < argc; i++) {
        if (!strcmp(argv[i], "--config-option")) {
            if (++i < argc)
                config_parse_option(config, strdup(argv[i]));
            else
                fprintf(stderr, "--config processes following option");
        }
    }

    if (!config_check(config))
        exit(1);

    if (!config_expand(config))
        exit(1);

    /* Don't need root privs after ports bound, files open */

    if (getuid() == 0) {
        if (config->prayer_gid)
            setgid(config->prayer_gid);

        if (config->prayer_uid)
            setuid(config->prayer_uid);
    }

    if (getuid() == 0)
        log_fatal("Configured to run as root!");

    iostream_init(config);      /* Required for SSL stuff */

    if (config->tmp_dir)
        chdir(config->tmp_dir);

    idled_server(config);

    /* NOTREACHED */
    return (0);
}
