/* $Cambridge: hermes/src/prayer/prayer/prayer-sem-prune.c,v 1.1 2004/11/16 18:19:06 dpc22 Exp $ */

/************************************************
 *    Prayer - a Webmail Interface              *
 ************************************************/

/* Copyright (c) University of Cambridge 2000 - 2004 */
/* See the file NOTICE for conditions of use and distribution. */

#include "prayer_shared.h"
#include "prayer.h"

#ifdef MUTEX_SEMAPHORE

#include <sys/types.h>
#include <sys/ipc.h>
#ifndef __USE_GNU
#define __USE_GNU       /* Evil hack to get prototype for semtimedop */
#include <sys/sem.h>
#undef __USE_GNU
#endif

union semun {
    int val;
    struct semid_ds *buf;
    ushort *array;
};

int
main(int argc, char *argv[])
{
    union semun ick;
    int sem_id;
    int i;

    if (argc < 2) {
        fprintf(stderr, "Arg: semaphore id (see ipcs -s)\n");
        exit(1);
    }

    for (i = 1 ; i < argc ; i++) {
        if ((sem_id = atoi(argv[i])) == 0)
            continue;

        printf("Removing %d\n", sem_id);

        ick.val = 0;
        semctl(sem_id, 0, IPC_RMID, ick);
    }

    exit(0);
}

#else

int
main(int argc, char *argv[])
{
    exit(0);
}
#endif
