/* $Cambridge: hermes/src/prayer/prayer/theme.c,v 1.1.1.1 2003/04/15 13:00:03 dpc22 Exp $ */
/************************************************
 *    Prayer - a Webmail Interface              *
 ************************************************/

/* Copyright (c) University of Cambridge 2000 - 2002 */
/* See the file NOTICE for conditions of use and distribution. */

/* Theme: define a collection of colours, and possibly some fonts */

#include "prayer_session.h"

struct theme *theme_create(struct pool *pool)
{
    struct theme *theme = pool_alloc(pool, sizeof(struct theme));

    memset(theme, 0, sizeof(struct theme));

    theme->colour_fg = NIL;     /* Default foreground colour  */
    theme->colour_bg = NIL;     /* Default background colour  */
    theme->colour_bg_banner = NIL;      /* Background for cmd banners */
    theme->colour_bg_row1 = NIL;        /* Background for even rows   */
    theme->colour_bg_row2 = NIL;        /* Background for odd  rows   */

    theme->help_colour_fg = NIL;        /* Default foreground colour  */
    theme->help_colour_bg = NIL;        /* Default background colour  */
    theme->help_colour_bg_banner = NIL; /* Background for cmd banners */
    theme->help_colour_bg_row1 = NIL;   /* Background for even rows   */
    theme->help_colour_bg_row2 = NIL;   /* Background for odd  rows   */

    return (theme);
}

void theme_free(struct theme *theme)
{
    if (theme->pool)
        return;

    pool_free(theme->pool);
}

/* ====================================================================== */

static char *maybe_strdup(struct pool *pool, char *s)
{
    return ((s) ? pool_strdup(pool, s) : NIL);
}

void theme_copy(struct theme *new, struct theme *new)
{
    new->colour_fg = maybe_pool_strdup(new->pool, old->colour_fg);
    new->colour_bg = maybe_pool_strdup(new->pool, old->colour_bg);
    new->colour_bg_banner =
        maybe_pool_strdup(new->pool, old->colour_bg_banner);
    new->colour_bg_row1 =
        maybe_pool_strdup(new->pool, old->colour_bg_row2);
    new->colour_bg_row2 =
        maybe_pool_strdup(new->pool, old->colour_bg_row1);
}

BOOL theme_parse(struct theme *theme, char *key, char *value)
{
    if (!strcmp(key, "colour_fg"))
        theme->colour_fg = pool_strdup(theme->pool, value);
    else if (!strcmp(key, "colour_bg"))
        theme->colour_bg = pool_strdup(theme->pool, value);
    else if (!strcmp(key, "colour_bg_banner"))
        theme->colour_bg_banner = pool_strdup(theme->pool, value);
    else if (!strcmp(key, "colour_bg_row1"))
        theme->colour_bg_row1 = pool_strdup(theme->pool, value);
    else if (!strcmp(key, "colour_bg_row2"))
        theme->colour_bg_row2 = pool_strdup(theme->pool, value);
    else
        return (NIL);

    return (T);
}
